> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# Find Customers

GET https://api.npretail.app/{tenant}/{environment}/{company}/customer/

Get a list of customers with pagination

Reference: https://docs.navipartner.com/apis/api-reference/customers/service-customer/get-customers

## Authentication

- `x-np-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `tenant` (string, required) — Your Entra Tenant ID. [More details.](/paths#1-tenant)
- `environment` (string, required) — Your Business Central Environment. [More details.](/paths#2-environment)
- `company` (string, required) — Your Business Central Company. [More details.](/paths#3-company)

### Query parameters

- `customerNo` (string, optional) — Filter customers by customer number
- `email` (string, optional) — Filter customers by email address
- `pageSize` (integer, optional)
- `pageKey` (string, optional)
- `lastRowVersion` (string, optional)
- `sync` (boolean, optional)

## Response

### 200

- `morePages` (boolean, required)
- `nextPageKey` (string, required)
- `nextPageURL` (string, required)
- `data` (list of ListCustomer, required)

## Types

### ListCustomer

Represents a customer in the system for list operations.

- `id` (UUID, required)
- `no` (string, required)
- `name` (string, required)
- `address` (string, required)
- `postCode` (string, required)
- `city` (string, required)
- `address2` (string, required)
- `county` (string, required)
- `countryCode` (string, required)
- `contact` (string, required)
- `email` (string, required)
- `phone` (string, required)
- `mobilePhone` (string, required)
- `ean` (string, required)
- `vatRegistrationNo` (string, required)
- `rowVersion` (integer, required)

## Examples

**Response**

```json
{
  "morePages": true,
  "nextPageKey": "c29tZSBiYXNlNjQgc3RyaW5n",
  "nextPageURL": "https://api.npretail.app/tenant/env/company/customer?pageKey=c29tZSBiYXNlNjQgc3RyaW5n&lastRowVersion=12345678901234567890",
  "data": [
    {
      "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
      "no": "CUST-10001",
      "name": "Acme Corporation",
      "address": "123 Main Street",
      "postCode": "10001",
      "city": "New York",
      "address2": "Suite 400",
      "county": "New York",
      "countryCode": "US",
      "contact": "Jane Doe",
      "email": "jane.doe@acme.com",
      "phone": "+1-555-123-4567",
      "mobilePhone": "+1-555-987-6543",
      "ean": "1234567890123",
      "vatRegistrationNo": "US123456789",
      "rowVersion": 12345678901234567000
    },
    {
      "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
      "no": "CUST-10001",
      "name": "Acme Corporation",
      "address": "123 Main Street",
      "postCode": "10001",
      "city": "New York",
      "address2": "Suite 400",
      "county": "New York",
      "countryCode": "US",
      "contact": "Jane Doe",
      "email": "jane.doe@acme.com",
      "phone": "+1-555-123-4567",
      "mobilePhone": "+1-555-987-6543",
      "ean": "1234567890123",
      "vatRegistrationNo": "US123456789",
      "rowVersion": 12345678901234567000
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./customer/"

querystring = {"pageSize":"50","customerNo":"CUST-10001","email":"jane.doe@acme.com"}

headers = {"x-np-api-key": "<NaviPartner API Key>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./customer/?pageSize=50&customerNo=CUST-10001&email=jane.doe%40acme.com';
const options = {method: 'GET', headers: {'x-np-api-key': '<NaviPartner API Key>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./customer/?pageSize=50&customerNo=CUST-10001&email=jane.doe%40acme.com"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./customer/?pageSize=50&customerNo=CUST-10001&email=jane.doe%40acme.com")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./customer/?pageSize=50&customerNo=CUST-10001&email=jane.doe%40acme.com")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./customer/?pageSize=50&customerNo=CUST-10001&email=jane.doe%40acme.com', [
  'headers' => [
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./customer/?pageSize=50&customerNo=CUST-10001&email=jane.doe%40acme.com");
var request = new RestRequest(Method.GET);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["x-np-api-key": "<NaviPartner API Key>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./customer/?pageSize=50&customerNo=CUST-10001&email=jane.doe%40acme.com")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```